#include <bits/stdc++.h>

using namespace std;
#define MAXN 500005
#define MAXBIT 58
typedef long long ll;
ll a[MAXN];
int cnt[MAXBIT];
int cntt[MAXBIT];
const ll LIMIT = 1e16;

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        for(int j = 0; j < MAXBIT; j++)
        {
            if(a[i]&(1LL<<j))cnt[j]^=1;
        }
    }
    ll ans = 1e18;
    for(int j = 0; j < MAXBIT; j++)
    {
        for(int k = 0; k < MAXBIT; k++)cntt[k]=cnt[k];
        ll s=0LL;
        bool moze = false;
        for(int i = 0; i < n; i++)
        {
            if(a[i]&(1LL<<j))continue;
            ll add=(1LL<<j);
            ll levo=0LL;
            ll desno=0LL;
            for(int k = 0; k < j; k++)
            {
                if(a[i]&(1LL<<k))levo+=(1LL<<k);
            }
            add=min(add,abs((1LL<<j)-levo));
            for(int k = j+1; k < MAXBIT; k++)
            {
                if(a[i]&(1LL<<k))
                {
                    desno+=(1LL<<k);
                    break;
                }
            }
            add=min(add,abs((1LL<<j)-desno));
            if(levo!=0&&desno!=0 && abs((1LL<<j)-levo)==abs((1LL<<j)-desno))moze=true;
            s+=add;
            if(s > LIMIT)break;
            cntt[j]^=1;
            if(levo != 0 && abs((1LL<<j)-levo)==add)
            {
                for(int k = 0; k < j; k++)
                {
                    if(a[i]&(1LL<<k))cntt[k]^=1;
                }
            }
            else if(desno != 0 && abs((1LL<<j)-desno)==add)
            {
                for(int k = j+1; k < MAXBIT; k++)
                {
                    if(a[i]&(1LL<<k))
                    {
                        cntt[k]^=1;
                        break;
                    }
                }
            }
        }
        for(int k = 0; k < MAXBIT; k++)
        {
            if(cntt[k]==1){moze=true;break;}
        }
        if(!moze)
        {
            if(j!=0)ans=min(ans,s+1);
            else ans=min(ans,s+2);
        }
        else ans=min(ans,s);
    }
    cout << ans;
    return 0;
}